#!/bin/bash

# Скрипт dp_bluetooth, первая часть - конфигурация служб Bluetooth в системных файлах
# Запускается на обеих машинах

#Step 1 - config files
if [ `grep SDPD_ENABLED /etc/default/bluetooth >/dev/null; echo $?` -eq 1 ]; then 
   echo "SDPD_ENABLED=1" >> /etc/default/bluetooth
fi

sed -i 's/^NOPLUGIN_OPTION="[^"]*"/NOPLUGIN_OPTION="-d --compat --experimental"/' /etc/init.d/bluetooth


for i in "Manager" "Adapter" "Device" "Service" "Database" "Security"
do
  if [ `grep "org.bluez.$i" /etc/dbus-1/system.d/bluetooth.conf >/dev/null; echo $?` -eq 1 ]; then
    sed -i 's/\(<allow send_interface="org.freedesktop.DBus.Properties"\/>\)/\1\n    <allow send_destination="org.bluez.'$i'"\/>\n    <allow receive_sender="org.bluez.'$i'"\/>/' /etc/dbus-1/system.d/bluetooth.conf
  fi
done  
for i in "Agent" "HandsfreeAgent" "PasskeyAgent"
do
  if [ `grep "org.bluez.$i" /etc/dbus-1/system.d/bluetooth.conf >/dev/null; echo $?` -eq 1 ]; then
    sed -i 's/\(<allow send_interface="org.freedesktop.DBus.ObjectManager"\/>\)/<allow send_interface="org.bluez.'$i'"\/>\n    \1/' /etc/dbus-1/system.d/bluetooth.conf
  fi
done  


#Step 2 - BT card config
#load bnep module
modprobe bnep

#(re)start bluetoothd
until [ `pgrep -f bluetoothd -c` -eq 0 ]
do
  service bluetooth stop
  sleep 3
done  

until [ `pgrep -f bluetoothd -c` -eq 1 ]
do
  service bluetooth start
  sleep 3
done  
