#!/bin/bash
# Скрипт dp_bluetooth, третья часть (пейринг)

if [ -n "$conffile" ]; then  #path to conf file not empty
  if [ -f "$conffile" ]; then  #conf file does not exist
    source $conffile
  fi
else
  echo "Configuration file not found. Exiting" | tee -a $logfile
  exit 1
fi


echo -e "scan on\nexit" | bluetoothctl
[[ "$mode" == "auto" ]] && ssh root@${serverIP} -C  "echo -e \"scan on\nexit\" | bluetoothctl"
sleep 2



btclientMAC=`hcitool dev | grep hci0 | awk '{ print $2 }'`

#Need to see server BT MAC before connecting
hcitool scan

if [ -z "$btserverMAC" ]; then
  if [ "$mode" == "auto" ]; then
    export btserverMAC=`ssh root@${serverIP} hcitool dev | grep hci0 | awk '{ print $2 }'`
  else
    echo "Variable btserverMAC is not defined. Exiting" | tee -a $logfile
    exit 1  
  fi
fi

hcitool cc $btserverMAC; 
hcitool auth $btserverMAC; result=$?
echo -e "trust $btserverMAC\nexit" | bluetoothctl
[[ "$mode" == "auto" ]] && ssh root@${serverIP} -C  "echo -e \"trust $btclientMAC\nexit\" | bluetoothctl"


#Return exit code depending on whether BT devices paired
exit $result
