#!/bin/bash

#Step 4 - create Eth bridge & register BNEP server
#DBus org.bluez.NetworkServer1.Register works only with Ethernet bridges, need one

if [ -n "$conffile" ]; then  #path to conf file not empty
  if [ -f "$conffile" ]; then  #conf file does not exist
    source $conffile
  fi
else
  echo "Configuration file not found. Exiting" | tee -a $logfile
  exit 1
fi

#Заплатка для ручного режима, когда неизвестно где конфиг файл и нет IP соединения между сервером и клиентом
#[[ -z "$btserverIP" ]] && export btserverIP="10.1.2.1"

brctl addbr bnep
brctl stp bnep off
brctl setfd bnep 0
ip addr add ${btserverIP}/24 dev bnep
ip link set bnep up

iperf3 -s -D

./bt-pan --debug server bnep &
