#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define MAX 1048576
#define CHK 32000
#define REP 2

#ifndef OHVAT
#define OHVAT 40000
#endif

long virt2phys (long virt)
{
  long res;
  asm ("ldgdd,2 0x0, %1, %0, mas = %2"
       : "=r" (res)
       : "ri" (virt), "i" ((0x7) | (0x5)<<3));
  return res;
}

int sample( );

double x = 1.0, y = 2.0, z = 3.0, t = 4.0, u = 5.0;

double *fa,
       *fb,
       *fc,
       *fd;

int sample()
{
    int i;

    typedef union {double d; long long i;} my_un;
    my_un ie;
    long long se=0;

    for( i = 262144; i <= 262144 + CHK; i++){
        ie.d =  fabs((x + fa[i] * y) + (fb[i] + z * fc[i]) * (t + fd[i] * u));
        se=se+ie.i;
    }

    return (int)(se);
}


int main()
{
    int ohvat;
    int i, j;
    int sum=0;

    fa=(double*)malloc(sizeof(double)*MAX);
    fb=(double*)malloc(sizeof(double)*MAX);
    fc=(double*)malloc(sizeof(double)*MAX);
    fd=(double*)malloc(sizeof(double)*MAX);

    for( i = 0; i < MAX; i++ ) {

       fa[i] =  4.0;
       fb[i] =  5.0;
       fc[i] =  6.0;
       fd[i] =  7.0;
    }

    for (ohvat=0; ohvat<OHVAT; ohvat++)
    {
        sum=0;

        for( j = 0; j < REP; j++ ) { // Measuring
            sum += sample( ); // peak loop
        }
    }

    return sum;
}

