


#define _GNU_SOURCE
#define __USE_GNU
#include <errno.h>
#include <sys/mman.h>
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include <pthread.h>
#include <unistd.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <pthread.h>
#include <sys/time.h>
#include <sys/sysinfo.h>
#include <sys/mount.h>
#include <stdint.h>
#include <sys/syscall.h>
#include <sys/mman.h>
#include <math.h>
#include <asm/unistd.h>
#include <signal.h>
#include <sched.h>






void usage(char *name)
{
	fprintf(stderr, "Usage :$s <int prio>[<F|R>[u|<int cpu>]] "
		" <cmd to execute> [cmd params ...]\n", name);
	return;
}



int main (int argc, char **argv)
{

	char			*cmd = NULL;
        struct sched_param      param;
	int			prio = 0 ;
	int			policy = SCHED_FIFO;
        cpu_set_t               mask;
	int			cpu = -1;
	char *ptr;
	int i;
	char **args;

        CPU_ZERO(&mask);


	if (argc < 3) {
		usage(argv[0]);
		return 1;
	}
	prio = strtol(argv[1], &ptr, 10);
	if ((prio < 0) || (prio > 98)) {
		fprintf(stderr, "%s : wrong priority %d\n", argv[0], prio);
		usage(argv[0]);
		return 1;
	}
	if (ptr[0] == 'F') {
		policy = SCHED_FIFO;
		ptr++;
	} else if (ptr[0] == 'R') {
                policy = SCHED_RR;
                ptr++;
	} else if (ptr[0] == 0) {
		goto scanned;
	}

	if (ptr[0] == 0) {
		goto scanned;
	}
	if (ptr[0] == 'u') {
		cpu = 0;
	} else {
		cpu = atoi(ptr);
		if (cpu < 0) {
			fprintf(stderr, "Wrong cpu %d\n", cpu);
			usage(argv[0]);
			exit(1);
		}
	}
	CPU_SET(cpu, &mask);

scanned:

        param.sched_priority = prio;
        if (sched_setscheduler(0, policy, &param)) {
		perror("sched_setscheduler ");
		return 1;
	}
	if (cpu >= 0) {
		if (sched_setaffinity(0, sizeof(cpu_set_t), &mask)) {
			perror("sched_setaffinity ");
			return 1;
		}
	}

	args = (char **)malloc((argc - 1)*sizeof(char **));
	if (args == NULL) {
		printf("Could not alloc memory\n");
		exit(1);
	}
	for (i = 2; i < argc; i++) {
		args[i - 2] = argv[i];
	}
	args[argc - 2] = NULL;
	return execvp(argv[2], args);
}


