#!/bin/bash

#set -x

get_num_cpu(){
    about=1
    #
    test "$(uname -m)" == "sparc64" && local about=$(cat /proc/cpuinfo | grep CPU | wc -l)
    test "$(uname -m)" != "sparc64" && local about=$(cat /proc/cpuinfo | grep processor | wc -l)
    #
    echo $about
}

alu_e2cdsp="16:8"
alu_e2s="16:8"
alu_e8c="24:12"
alu_e1c="24:12"
alu_e8c2="48:24"
alu_e16c="48:24"

alu_r1000='4:2'
alu_r2000='4:2'

head_platform=$(uname -m)
#
if test `uname -m` = 'e2k';then
    platform=`uname -p | sed 's/+//g' | tr '[:upper:]' '[:lower:]'`
else
    platform=`uname -i | tr '[:upper:]' '[:lower:]'`
fi

alu_name="alu_$platform"
alu_data=${!alu_name}
#
num_cpu=$(get_num_cpu)
#
mnz=0
for i in $(cat /proc/cpuinfo | grep 'MHz' | awk -F':' '{print $2}');do
    mnz=$(bc <<< "scale=2; $mnz+$i")
done
#
mnz=$(bc <<< "scale=2; $mnz/$num_cpu")

if [[ "$head_platform" == "e2k" ]] || [[ "$head_platform" == "sparc64" ]];then
    # calc
    alu_32=$(echo $alu_data | cut -d ':' -f1)
    alu_64=$(echo $alu_data | cut -d ':' -f2)
    #
    float_32_s=$(bc <<< "scale=2; $alu_32*$mnz*1/1000")
    float_64_s=$(bc <<< "scale=2; $alu_64*$mnz*1/1000")
    #
    echo "----------------"
    echo "SingleThread"
    echo "----------------"
    #
    echo "float-32: $float_32_s GFLOPs"
    echo "float-64: $float_64_s GFLOPs"
    # calc
    float_32_m=$(bc <<< "scale=2; $alu_32*$mnz*$num_cpu/1000")
    float_64_m=$(bc <<< "scale=2; $alu_64*$mnz*$num_cpu/1000")
    echo "----------------"
    #
    echo "MultiThread"
    echo "----------------"
    #
    echo "float-32: $float_32_m GFLOPs"
    echo "float-64: $float_64_m GFLOPs"
    #
    echo "----------------"

else
    echo "Unknown platform"
fi

